{$M 32768,0,655360}
{$R+,Q+,S+,I+,A+}
{$C permanent preload}
Uses Crt, Strings, WinDos;
{$G program,crt,strings,windos,system}
{$S 65535}
{$D NES-sources}

Procedure BHex(s: PChar; b: Byte);
Const HC: Array[0..15]Of Char = '0123456789ABCDEF';
Begin
	s[0] := HC[b Shr 4];
	s[1] := HC[b And 15];
	s[2] := #0
End;

Procedure WHex(s: PChar; w: Word);
Begin
	BHex(s+0, WordRec(w).Hi);
	BHex(s+2, WordRec(w).Lo)
End;

Procedure LHex(s: PChar; l: LongInt);
Begin
	WHex(s+0, LongRec(l).Hi);
	WHex(s+4, LongRec(l).Lo);
End;

Var
	Counter:  LongInt;

Const
	Ac=0; Zx=5; Ix=10;
	Il=1; Zy=6; Iy=11;
	Im=2; Ax=7;_In=12;
	Ab=3; Ay=8; Iw=13;
	Zp=4; Rl=9;
	No=127;

	(* These are the addressation methods used by 6502 CPU. *)

Const MN: Array[0..69]Of Array[0..9]Of Char =
(
{ 0}	'adc a,','and a,','sal',     'jnc',     'jc',      'je',      'bit',     'js',
{ 8}	'jne'   ,'jns'   ,'brk',     'jno',     'jo',      'clc',     'clD',     'cli',
{16}	'clo'   ,'cmp a,','cmp x,',  'cmp y,',  'dec',     'dec x',   'dec y',   'inc x',
{24}	'inc y' ,'xor a,','inc',     'jmp',     'call',    'mov a,',  'nop',     'mov x,',
{32}	'mov y,','shr'   ,'or a,',   'push a',  'pushf',   'pop a',   'popf',    'rol',
{40}	'ror'   ,'iret'  ,'ret',     'sbb a,',  'sta',     'stx',     'sty',     'stc',
{48}	'stD'   ,'sti'   ,'mov x, a','mov y, a','mov a, x','mov a, y','mov x, s','mov s, x',
			{Undocumented.}
{56}	'arr ?' ,'tilt ?','nop+tilt','slo ?',   'shy ?',   'dcp ?',   'rla ?',   'sre ?',
{64}  'rra ?' ,'sax ?' ,'lax ?',   'isb ?',   'anc ?',   'asr ?'
);
{D-flag does not mean direction - it means decimal mode}

Const
	AD: Array[0..511]Of Byte =
(
	10,Il, 34,Ix, 57,Il, 59,Ix, 30,Il, 34,Zp,  2,Zp, 59,Zp, {00}
	36,Il, 34,Im,  2,Ac, 68,Im, 30,Il, 34,Ab,  2,Ab, 59,Ab, {08}
	 9,Rl, 34,Iy, 57,Il, 59,Iy, 30,Il, 34,Zx,  2,Zx, 59,Zx, {10}
	13,Il, 34,Ay, No,No, 59,Ay, 30,Il, 34,Ax,  2,Ax, 59,Ax, {18}
	28,Iw,  1,Ix, 57,Il, 62,Ix,  6,Zp,  1,Zp, 39,Zp, 62,Zp, {20}
	38,Il,  1,Im, 39,Ac, 68,Im,  6,Ab,  1,Ab, 39,Ab, 62,Ab, {28}
	 7,Rl,  1,Iy, 57,Il, 62,Iy, 30,Il,  1,Zx, 39,Zx, 62,Zx, {30}
	47,Il,  1,Ay, No,No, 62,Ay, 30,Il,  1,Ax, 39,Ax, 62,Ax, {38}
	41,Il, 25,Ix, 57,Il, 63,Ix, 30,Il, 25,Zp, 33,Zp, 63,Zp, {40}
	35,Il, 25,Im, 33,Ac, 69,Im, 27,Iw, 25,Ab, 33,Ab, 63,Ab, {48}
	11,Rl, 25,Iy, 57,Il, 63,Iy, 30,Il, 25,Zx, 33,Zx, 63,Zx, {50}
	15,Il, 25,Ay, No,No, 63,Ay, 30,Il, 25,Ax, 33,Ax, 63,Ax, {58}
	42,Il,  0,Ix, 57,Il, 64,Ix, 30,Il,  0,Zp, 40,Zp, 64,Zp, {60}
	37,Il,  0,Im, 40,Ac, 56,Im, 27,_In, 0,Ab, 40,Ab, 64,Ab, {68}
	12,Rl,  0,Iy, 57,Il, 64,Iy, 30,Il,  0,Zx, 40,Zx, 64,Zx, {70}
	49,Il,  0,Ay, No,No, 64,Ay, 30,Il,  0,Ax, 40,Ax, 64,Ax, {78}
	30,Il, 44,Ix, 58,Il, 65,Ix, 46,Zp, 44,Zp, 45,Zp, 65,Zp, {80}
	22,Il, 30,Il, 52,Il, No,No, 46,Ab, 44,Ab, 45,Ab, 65,Ab, {88}
	 3,Rl, 44,Iy, 57,Il, No,No, 46,Zx, 44,Zx, 45,Zy, No,No, {90}
	53,Il, 44,Ay, 55,Il, No,No, 60,Il, 44,Ax, No,No, No,No, {98}
	32,Im, 29,Ix, 31,Im, 66,Ix, 32,Zp, 29,Zp, 31,Zp, 66,Zp, {A0}
	51,Il, 29,Im, 50,Il, No,No, 32,Ab, 29,Ab, 31,Ab, 66,Ab, {A8}
	 4,Rl, 29,Iy, 57,Il, No,No, 32,Zx, 29,Zx, 31,Zy, No,No, {B0}
	16,Il, 29,Ay, 54,Il, No,No, 32,Ax, 29,Ax, 31,Ay, No,No, {B8}
	19,Im, 17,Ix, 58,Il, 61,Ix, 19,Zp, 17,Zp, 20,Zp, 61,Zp, {C0}
	24,Il, 17,Im, 21,Il, No,No, 19,Ab, 17,Ab, 20,Ab, 61,Ab, {C8}
	 8,Rl, 17,Iy, 57,Il, 61,Iy, 30,Il, 17,Zx, 20,Zx, 61,Zx, {D0}
	14,Il, 17,Ay, 30,Il, 61,Ay, 30,Il, 17,Ax, 20,Ax, 61,Ax, {D8}
	18,Im, 43,Ix, 58,Il, 67,Ix, 18,Zp, 43,Zp, 26,Zp, 67,Zp, {E0}
	23,Il, 43,Im, 30,Il, No,No, 18,Ab, 43,Ab, 26,Ab, 67,Ab, {E8}
	 5,Rl, 43,Iy, 57,Il, 67,Iy, 30,Il, 43,Zx, 26,Zx, 67,Zx, {F0}
	48,Il, 43,Ay, 30,Il, 67,Ay, 30,Il, 43,Ax, 26,Ax, 67,Ax  {F8}
);

Var
	Pages: Array[0..15]Of Integer;
	RelAddr: LongInt;
	OP: Word;
	C: PChar;

	pROM: Array[0..63]Of PChar;
	pROMCount: Integer;

	vROM: Array[0..63]Of PChar;
	vROMCount: Integer;

	fROM: Array[-8..63]Of PChar;
	{bit values:}
	{ 1 = Has executable code}
	{ 2 = Is part of instruction}
	{ 4 = Has to be disassembled}
	{ 8 = }
	{10 = }
	{20 = }
	{40 = }
	{80 = Has been read}

	Trainer: PChar;

	HasTrainer: Boolean;

	NESFlags: Word;
	Mapper: Byte;

	TBuf, HexBuf: Array[0..79]Of Char;

Procedure fROMCheck(Var fROMPtr: PChar);
Begin
	If fROMPtr = Nil Then
	Begin
		GetMem(fROMPtr, 4096);
		FillChar(fROMPtr^, 4096, 0)
	End
End;

(** DAsm() ****************************************************)
(** This function will disassemble a single command and      **)
(** return the number of bytes disassembled.                 **)
(**************************************************************)
Function DAsm(S, A: PChar; PC: LongInt): Integer;
Var
	w: Word;
	B: PByte;
	J: Byte;
	q, t: Boolean;
	p: Integer;
Begin
	B := PByte(A);
	C := A;
	OP := (B^)*2; Inc(B);

	If S = Nil Then S := HexBuf+9;

{	WHex(s, PtrRec(B).Seg); Write('B = ',s);
	WHex(s, PtrRec(B).Ofs); WriteLn(':',s);

}	If AD[OP] <> No Then strcpy(s, MN[AD[OP]]);

	q := False; {data addressed}
	t := False; {index-addressed}

	Case AD[OP+1]Of
		Ac: If s <> Nil Then strcat(s, ' a');
		Im:
		Begin
			RelAddr := B^;
			strcat(s, ' ');
			BHex(strend(s), B^);
			Inc(B)
		End;
		Il: ;
		Rl:
		Begin
			J := B^; Inc(B);
			Inc(PC, 2);
			If J<$80 Then Inc(PC, J)Else Inc(PC, J-256);
			strcat(s, ' ');
			RelAddr := PC;
			LHex(strend(s), PC)
		End;
		Zp:
		Begin
			RelAddr := B^;
			strcat(s, ' [00');
			BHex(strend(s), B^);
			strcat(s, ']');
			q := True;
			Inc(B)
		End;
		Zx:
		Begin
			RelAddr := B^;
			strcat(s, ' [00');
			BHex(strend(s), B^);
			strcat(s, '+x]');
			q := True;
			t := True;
			Inc(B)
		End;
		Zy:
		Begin
			RelAddr := B^;
			strcat(s, ' [00');
			BHex(strend(s), B^);
			strcat(s, '+y]');
			q := True;
			t := True;
			Inc(B)
		End;
		Ix:
		Begin
			RelAddr := B^;
			strcat(s, ' [word[(x+');
			BHex(strend(s), B^);
			strcat(s, ')&FF]]');
			q := True;
			t := True;
			Inc(B)
		End;
		Iy:
		Begin
			RelAddr := B^;
			strcat(s, ' [y+word[00');
			BHex(strend(s), B^);
			strcat(s, ']]');
			q := True;
			Inc(B)
		End;
		_In: {only used in indirect jump}
		Begin
			w := B^          ; Inc(B);
			w := B^ Shl 8 + w; Inc(B);
			RelAddr := w;
			strcat(s, ' [');
			WHex(strend(s), w);
			strcat(s, ']');
			q := True
		End;
		Ab: {used when addressing}
		Begin
			w :=           B^; Inc(B);
			w := B^ Shl 8 + w; Inc(B);
			RelAddr := w;
			strcat(s, ' [');
			WHex(strend(s), w);
			strcat(s, ']');
			q := True
		End;
		Iw: {used in jsr/jmp}
		Begin
			w :=           B^; Inc(B);
			w := B^ Shl 8 + w; Inc(B);
			RelAddr := w;
			strcat(s, ' ');
			WHex(strend(s), w)
		End;
		Ax:
		Begin
			w := B^          ; Inc(B);
			w := B^ Shl 8 + w; Inc(B);
			RelAddr := w;
			strcat(s, ' [');
			WHex(strend(s), w);
			strcat(s, '+x]');
			t := True;
			q := True
		End;
		Ay:
		Begin
			w := B^          ; Inc(B);
			w := B^ Shl 8 + w; Inc(B);
			RelAddr := w;
			strcat(s, ' [');
			WHex(strend(s), w);
			strcat(s, '+y]');
			t := True;
			q := True
		End;
		Else
		Begin
			strcpy(s, 'db ');
			BHex(strend(s), OP Shr 1)
		End;
	End;

	If q Then
	Begin
		p := Pages[RelAddr Shr 12];

		fROMCheck(fROM[p]);

		fROM[p][RelAddr And $FFF] := Chr(Ord(fROM[p][RelAddr And $FFF])Or 8);
		If t Then
			fROM[p][RelAddr And $FFF] := Chr(Ord(fROM[p][RelAddr And $FFF])Or 4)
	End;

	If(s[0]='s')And(s[1]='t')And(s[3]<>#0)Then
	Begin
		Case s[2]Of
			'a': strcat(s, ', a');
			'x': strcat(s, ', x');
			'y': strcat(s, ', y')
		End;
		s[0] := 'm';
		s[1] := 'o';
		s[2] := 'v'
	End;

	If AD[OP]In[33,2,39,40]Then strcat(s, ', 1');
{
	If AD[OP] >= 56 Then
	Begin
		p := (strlen(s)+2)Div 8;
		While p < 3 Do
		Begin
			Inc(p);
			strccat(s, #9)
		End;
		strcat(s, '; strange opcode ');
		BHex(strend(s), OP Shr 1)
	End;}

	DAsm := PChar(B) - A
End;

Function Run(w: Word): Boolean; Forward; {True if terminated with ret}

Procedure Set4kPage(Num: Byte; i: Integer);
Var a: Byte;
Begin
	If i >= pROMCount Then i := pROMCount - 1;
	Pages[8+Num] := i
End;

Function CondJump(How: Byte): Boolean; {Returns true if sub terminates with ret}
Var
	a: Word;
	i: Integer;
Begin
	i := Pages[RelAddr Shr 12];
	a := RelAddr And $FFF;

	fROMCheck(fROM[i]);

	fROM[i][a] := Chr(Ord(fROM[i][a])Or How); {viitattu}

	CondJump := Run(RelAddr) {kydn sekin lpi ettei unohdu}
End;

Procedure SimulLD(Var Reg: Byte);
Begin
	Case AD[OP+1]Of
		Im: Reg := RelAddr;
	End;
End;

Procedure SimulST(Var Reg: Byte);
Const Mappe4Cmd: Byte = 0;
Begin
	If Reg=255 Then Exit; {unknown state}

	Case AD[OP+1]Of
		Ab:
			Case Mapper Of
				2: If RelAddr >= $8000 Then
				Begin
					Set4kPage(0, Reg*4  );
					Set4kPage(1, Reg*4+1);
					Set4kPage(2, Reg*4+2);
					Set4kPage(3, Reg*4+3)
				End;
				4:
					If RelAddr = $8000 Then Mappe4Cmd := Reg
					Else If RelAddr = $8001 Then
						Case Mappe4Cmd Of
							6:
							Begin
								Set4kPage(0, Reg*2  );
								Set4kPage(1, Reg*2+1)
							End;
							7:
							Begin
								Set4kPage(2, Reg*2  );
								Set4kPage(3, Reg*2+1)
							End;
						End
			End;
	End
End;

Var
	Reg_A,
	Reg_X,
	Reg_Y: Byte;

Function RegStep(i: Integer; Buf: PChar; Jumps: Boolean; p, w: Word): Boolean;
Const LastOp: Byte = 0;
Var j: Integer; ra: LongInt;
Begin
	RegStep := False;

	j := LastOp;
	LastOp := i;
	Case i Of
		 3: {bcc} Begin If j= 4 Then RegStep := True; If Jumps Then CondJump($10)End;
		 4: {bcs} Begin If j= 3 Then RegStep := True; If Jumps Then CondJump($10)End;
		 8: {bne} Begin If j= 5 Then RegStep := True; If Jumps Then CondJump($10)End;
		 5: {beq} Begin If j= 8 Then RegStep := True; If Jumps Then CondJump($10)End;
		 9: {bpl} Begin If j= 7 Then RegStep := True; If Jumps Then CondJump($10)End;
		 7: {bmi} Begin If j= 9 Then RegStep := True; If Jumps Then CondJump($10)End;
		11: {bvc} Begin If j=12 Then RegStep := True; If Jumps Then CondJump($10)End;
		12: {bvs} Begin If j=11 Then RegStep := True; If Jumps Then CondJump($10)End;

		 2: {asl}; 33: {lsr};
		39: {rol}; 40: {ror};

		 0: {adc}; 43: {sbc};

		21: {dex} Dec(Reg_X);
		23: {inx} Inc(Reg_X);
		22: {dey} Dec(Reg_Y);
		24: {iny} Inc(Reg_Y);
		20: {dec}; 26: {inc};

		13: {clc}; 47: {sec};
		14: {cld}; 48: {sed};
		15: {cli}; 49: {sei};
		16: {clv};

		50: {tax} Reg_A := Reg_X;
		51: {tay} Reg_A := Reg_Y;
		52: {txa} Reg_X := Reg_A;
		53: {tya} Reg_Y := Reg_A;
		55, {txs}  54: {tsx};

		27: {jmp} Begin If(AD[OP+1] = Iw)And Jumps Then CondJump($10); RegStep := True {jumped}End;
		28: {jsr}
			If(AD[OP+1] = Iw)And Jumps Then
			Begin
				ra := RelAddr;
				If CondJump($80)Then
				Begin
					RegStep := True; {called}
					fROM[Pages[ra Shr 12]][ra And $FFF] := Chr(Ord(fROM[Pages[ra Shr 12]][ra And $FFF])Or 4)
				End
			End;

		10, {brk}  41, {rti}  42: {rts} RegStep := True;
		58: {nop+tilt} RegStep := True;

		35: {pha}; 37: {pla} Reg_A := 255;
		36: {php}; 38: {plp};

		29: {lda} SimulLD(Reg_A);
		31: {ldx} SimulLD(Reg_X);
		32: {ldy} SimulLD(Reg_Y);

		44: {sta} SimulST(Reg_A);
		45: {stx} SimulST(Reg_X);
		46: {sty} SimulST(Reg_Y);

		17, {cmp}  18, {cpx}  19: {cpy};

		 1: {and} If(AD[OP+1]=Im)And(Reg_A <> 255)Then Reg_A := Reg_A And Ord(Buf[1])Else Reg_A := 255;
		34: {ora} If(AD[OP+1]=Im)And(Reg_A <> 255)Then Reg_A := Reg_A  Or Ord(Buf[1])Else Reg_A := 255;
		25: {eor} If(AD[OP+1]=Im)And(Reg_A <> 255)Then Reg_A := Reg_A Xor Ord(Buf[1])Else Reg_A := 255;

		 6: {bit} Reg_A := 255;
		No: {unknown};
	End
End;

Function Run(w: Word): Boolean; {True if sub terminated with indirect jump}
Var
	Buf: Array[0..7]Of Char;
	p, i: Integer;
	a, b: Word;
	SavedLoc: LongInt;
	wx, wy: Byte;
Label P1;
Begin
	Run := False;

	If Pages[w Shr 12] < 0 Then
	Begin
{		WHex(HexBuf, w);
		WriteLn(#13^J'Invalid code address: ',HexBuf);}
		Exit
	End;
	wx := WhereX;
	wy := WhereY;
	Write('.');
	Repeat
		p := Pages[w Shr 12];

		fROMCheck(fROM[p]);
{		fROM[p][w And $FFF] := Chr(Ord(fROM[p][w And $FFF])And Not 4);}

{		If Ord(fROM[p][w And $FFF])And 4 = 4 Then Run := True;}
		If Ord(fROM[p][w And $FFF])And 3 <> 0 Then
		Begin
			If Ord(fROM[p][w And $FFF])And 8 = 0 Then
				fROM[p][w And $FFF] := Chr(Ord(fROM[p][w And $FFF])Or $20);
			Break
		End;

		If w > $FFFA Then Break;

		Buf[0] := pROM[Pages[(w+0)Shr 12]][(w+0)And $FFF];
		Buf[1] := pROM[Pages[(w+1)Shr 12]][(w+1)And $FFF];
		Buf[2] := pROM[Pages[(w+2)Shr 12]][(w+2)And $FFF];
		Buf[3] := pROM[Pages[(w+3)Shr 12]][(w+3)And $FFF];

		i := DAsm(TBuf, Buf, w);

		fROMCheck(fROM[p]);
		fROM[p][w And $FFF] := Chr(Ord(fROM[p][w And $FFF])Or 1);
		For a := 1 To i-1 Do
		Begin
			b := Pages[(w+a)Shr 12];
			fROMCheck(fROM[b]);
			fROM[b][(w+a)And $FFF] := Chr(Ord(fROM[b][(w+a)And $FFF])Or 2)
		End;

{		If OP Shr 1 = $6C Then Run := True;}

		If RegStep(AD[OP], Buf, True, p, w)Then Break;

		Inc(w, i)
	Until False;

	fROMCheck(fROM[p]);
	fROM[p][w And $FFF] := Chr(Ord(fROM[p][w And $FFF])Or $40);

	GotoXY(wx, wy);
	Write(' '^H)
End;

Procedure DoIt(s: PChar);
Var
	Indent, i, j, k: Integer;
	Buf: Array[0..127]Of Char;
	h, cd: Boolean;
	f: File;
	o, w, a, b,
	HexDump: Word;
	WordFFFA,
	WordFFFC,
	WordFFFE: Word;
	l, n: LongInt;
Label P1, P2;
Begin
	Assign(f, s);
	Reset(f, 1);
	BlockRead(f, Buf, 4);
	Buf[4] := #0;
	If strcmp(Buf, 'NES'^Z) <> 0 Then
	Begin
		WriteLn('Unknown format. Assuming ROM dump.');
		Seek(f, 0);
		pROMCount := FileSize(f)Div 4096;
		vROMCount := 0;
		NESFlags := 0;
		Goto P1
	End;
	BlockRead(f, pROMCount, 1);
	BlockRead(f, vROMCount, 1);

	pROMCount := pROMCount*4; {16kB divided into 4kB blocks}
	vROMCount := vROMCount*2; { 8kB divided into 4kB blocks}

	BlockRead(f, NESFlags, 2);
	Mapper := (Lo(NESFlags)Shr 4) + (Hi(NESFlags)And $F0);

	BlockRead(f, Buf, 8); {Should be zeroes all}
												{Not something like "diskdude"}
P1:
	HASTrainer := (NESFlags And 4 <> 0);

	If HASTrainer Then
	Begin
		GetMem(Trainer, 512);
		BlockRead(f, Trainer^, 512);
	End;

	For i := 0 To pROMCount-1 Do
	Begin
		GetMem(pROM[i], 4096);
		BlockRead(f, pROM[i]^, 4096);
	End;

	FillChar(fROM, SizeOf(fROM), 0);

	For i := 0 To vROMCount-1 Do
	Begin
		GetMem(vROM[i], 4096);
		BlockRead(f, vROM[i]^, 4096)
	End;

	l := FileSize(f)-FilePos(f);
	If l <> 0 Then
	Begin
		If l = 128 Then
		Begin
			BlockRead(f, Buf, 128);
			i := strlen(Buf);
			If(i > 0)And((Buf[i-1] = #26))Then Buf[i-1] := #0;
			WriteLn('Found game name record: ', Buf)
		End
		Else
			WriteLn('Garbage after should-be file end ignored. (',l,' bytes)')
	End;

	WriteLn('File has pROM ', pROMCount*4,'kB, vROM ',vROMCount*4,'kB.');
	Write('Mapper type is ',Mapper,' (');
	Case Mapper Of
		0: Write('no mapper, ok');
		2: Write('megaman2 mapper');
		Else Write('unsupported!')
	End;
	WriteLn(')');

	Close(f);

	For i := 0 To 3 Do
	Begin
		Pages[ 8+i] := i;
		Pages[12+i] := i+pROMCount-4;
	End;
	For i := 0 To 7 Do
		Pages[i] := -8 + i;

	WordRec(WordFFFA).Lo := Ord(pROM[Pages[15]][$FFA]);
	WordRec(WordFFFA).Hi := Ord(pROM[Pages[15]][$FFB]);
	WordRec(WordFFFC).Lo := Ord(pROM[Pages[15]][$FFC]);
	WordRec(WordFFFC).Hi := Ord(pROM[Pages[15]][$FFD]);
	WordRec(WordFFFE).Lo := Ord(pROM[Pages[15]][$FFE]);
	WordRec(WordFFFE).Hi := Ord(pROM[Pages[15]][$FFF]);

	WriteLn('Free memory: ',MaxAvail,' bytes');

	If WordFFFC < $8000 Then
		WriteLn('Trouble... The execution does not begin in ROM?!?');

	WriteLn('Scanning... (1)');
	RelAddr := WordFFFA; CondJump($10);
	WriteLn('Scanning... (2)');
	RelAddr := WordFFFC; CondJump($10);
	WriteLn('Scanning... (3)');
	RelAddr := WordFFFE; CondJump($10);

{P2:
	WriteLn('Scanning... (n)');
	HexDump := $FFFF;
	For a := 0 To pROMCount-1 Do
	Begin
		If fROM[a] = Nil Then Continue;
		For b := 0 To 4095 Do
		Begin
			If(Ord(fROM[a][b])And 3 = 1)
			And((Ord(fROM[a][b])And 8 = 0)Or cd)Then
			Begin
				HexDump := $FFFF;

				If a >= pROMCount-4 Then
					l := (a-pROMCount+16)Shl 12 + b
				Else
				Begin
					l := b + (8 + a And 3)Shl 12;
					WordRec(LongRec(l).Hi).Lo := a Div 4
				End;

				n := b + LongInt(a)Shl 12;

				w := LongRec(l).Lo;

				Buf[124] := pROM[(n+0)Shr 12][(n+0)And $FFF];
				Buf[125] := pROM[(n+1)Shr 12][(n+1)And $FFF];
				Buf[126] := pROM[(n+2)Shr 12][(n+2)And $FFF];
				Buf[127] := pROM[(n+3)Shr 12][(n+3)And $FFF];
				i := DAsm(TBuf, Buf+124, w);

				RegStep(AD[Ord(Buf[124])*2], Buf+124, False, 0, 0);

				h := False;

				cd := True;

				If Ord(fROM[Pages[RelAddr Shr 12]][RelAddr And $FFF])And 4 = 4 Then
					HexDump := b+i
			End
			Else If Ord(fROM[a][b])And 3 <> 2 Then
			Begin
				If HexDump < $FFFF Then
					If b < HexDump Then HexDump := $FFF
					Else If Not Odd(b-HexDump)Then
					Begin
						If a >= pROMCount-4 Then
							l := (a-pROMCount+16)Shl 12 + b
						Else
						Begin
							l := b + (8 + a And 3)Shl 12;
							WordRec(LongRec(l).Hi).Lo := a Div 4
						End;

						n := b + LongInt(a)Shl 12;

						w := LongRec(l).Lo;

						WordRec(k).Lo := Ord(pROM[(n+0)Shr 12][(n+0)And $FFF]);
						WordRec(k).Hi := Ord(pROM[(n+1)Shr 12][(n+1)And $FFF]);

						RelAddr := Word(k);

						k := Pages[RelAddr Shr 12];
						fROMCheck(fROM[k]);
						If Ord(fROM[k][RelAddr And $FFF])And 3 = 0 Then
						Begin
							CondJump($10);
							Goto P2
						End
					End;
				cd := False
			End;

			If Ord(fROM[a][b])And $60 <> 0 Then
			Begin
				h := True;
				Case Ord(fROM[a][b])And $60 Of
					$20: ;
					$40: ;
					$60: h := False
				End
			End
		End
	End;
}
	WriteLn('Disassembling.');
	SwapInOut;
	Indent := 4;
	HexDump := $FFFF;

	For a := 0 To pROMCount-1 Do
	Begin
		If fROM[a] = Nil Then Continue;
		For b := 0 To 4095 Do
		Begin
			If(Ord(fROM[a][b])And 3 = 1)
			And((Ord(fROM[a][b])And 8 = 0)Or cd)Then
			Begin
				HexDump := $FFFF;

				If a >= pROMCount-4 Then
					l := (a-pROMCount+16)Shl 12 + b
				Else
				Begin
					l := b + (8 + a And 3)Shl 12;
					WordRec(LongRec(l).Hi).Lo := a Div 4
				End;

				n := b + LongInt(a)Shl 12;

				w := LongRec(l).Lo;

				Buf[124] := pROM[(n+0)Shr 12][(n+0)And $FFF];
				Buf[125] := pROM[(n+1)Shr 12][(n+1)And $FFF];
				Buf[126] := pROM[(n+2)Shr 12][(n+2)And $FFF];
				Buf[127] := pROM[(n+3)Shr 12][(n+3)And $FFF];

				i := DAsm(TBuf, Buf+124, w);

				If AD[OP+1] = Iw Then {jmp/call iw}
				Begin
					If AD[Ord(Buf[124])*2] = 28
						Then {call} k := 5
						Else {jmp } k := 4;
					{Siirretn offsettia hieman}
					TBuf[k+7] := #0;
					TBuf[k+6] := TBuf[k+3];
					TBuf[k+5] := TBuf[k+2];
					TBuf[k+4] := TBuf[k+1];
					TBuf[k+3] := TBuf[k  ];
					TBuf[k+2] := '0';
					TBuf[k+1] := '0';
					j := Integer(PWord(Buf+125)^ - $8000);
					Case Ord(fROM[(Word(j)Shr 12)+a][Word(j)And $FFF])And $80 Of
						$00: TBuf[k] := 'J';
						$80: TBuf[k] := 'C';
					End
				End;

				RegStep(AD[Ord(Buf[124])*2], Buf+124, False, 0, 0);

				If w = WordFFFA Then Begin If Not h Then WriteLn; h := True; WriteLn('; *** The NMI vector ***')   End;
				If w = WordFFFC Then Begin If Not h Then WriteLn; h := True; WriteLn('; *** The RESET vector ***') End;
				If w = WordFFFE Then Begin If Not h Then WriteLn; h := True; WriteLn('; *** The IRQ vector ***')   End;
				If Ord(fROM[a][b])And $90 <> 0 Then h := True;
				{h = true jos tss oli joku labeli nyt}

				LHex(HexBuf, l);

				Buf[0] := #0;
				If h Then {oliko label?}
				Begin
					{a=rom page, b=offset inside page}
					{$IFOPT T+ niinkuin turhaa koodia}Case Ord(fROM[a][b])And $90 Of
						$00: strcat(Buf, 'P');
						$10: strcat(Buf, 'J');
						$90: strcat(Buf, 'Z');
						$80: strcat(Buf, 'C');
					End;{$ENDIF}
					Case Ord(fROM[a][b])And $80 Of
						$00: strcat(Buf, 'J');
						$80: strcat(Buf, 'C');
					End;

					strcat(Buf, HexBuf+2);
					strcat(Buf, ':')
				End;

				k := strlen(Buf)Div 8;
				While k < 1 Do
				Begin
					strccat(Buf, #9);
					Inc(k)
				End;

				If AD[OP]In[37,38] Then Dec(Indent);

				For k := 1 To Indent Do strccat(Buf, ' ');
				strcat(Buf, TBuf);

				If AD[OP]In[35,36] Then Inc(Indent);

				k := 0;
				For j := 0 To strlen(Buf)-1 Do
					If Buf[j] = #9
						Then Repeat Inc(k)Until k And 7=0
						Else Inc(k);

				k := k Div 8;
				While k < 4 Do
				Begin
					strccat(Buf, #9);
					Inc(k)
				End;

				strcat(Buf, '; ');

				For k := 1 To i Do
				Begin
					BHex(strend(Buf), Ord(Buf[123+k]));
					If k < i Then strccat(Buf, ' ')
				End;

				If AD[Ord(Buf[124])*2] >= 56 Then
					strcat(Buf, ' - strange opcode');

				If(AD[Ord(Buf[124])*2] = 30)And(Buf[124] <> #$EA)Then
					strcat(Buf, ' - strange way');

				WriteLn(Buf);

				h := False;

				cd := True;
				(*
				If Ord(fROM[Pages[RelAddr Shr 12]][RelAddr And $FFF])And 4 = 4 Then
					HexDump := b+i*)
			End
			Else If Ord(fROM[a][b])And 3 <> 2 Then
			Begin
				(*If HexDump < $FFFF Then
					If b < HexDump Then HexDump := $FFF
					Else If Not Odd(b-HexDump)Then
					Begin
						If a >= pROMCount-4 Then
							l := (a-pROMCount+16)Shl 12 + b
						Else
						Begin
							l := b + (8 + a And 3)Shl 12;
							WordRec(LongRec(l).Hi).Lo := a Div 4
						End;

						n := b + LongInt(a)Shl 12;

						w := LongRec(l).Lo;

						LHex(HexBuf, l);

						strcpy(Buf, 'R');
						strcat(Buf, HexBuf+2);
						strcat(Buf, ':');
						For k := 1 To Indent Do strccat(Buf, ' ');
						strcat(Buf, 'dw 0');

						WordRec(k).Lo := Ord(pROM[(n+0)Shr 12][(n+0)And $FFF]);
						WordRec(k).Hi := Ord(pROM[(n+1)Shr 12][(n+1)And $FFF]);

						WHex(strend(Buf), Word(k));

						{RelAddr := Word(k); CondJump($10);

						}strcat(Buf, 'h');

						WriteLn(Buf)
					End;*)
				cd := False
			End;

			If Ord(fROM[a][b])And $60 <> 0 Then
			Begin
				h := True;
				Case Ord(fROM[a][b])And $60 Of
					$20: WriteLn('; already disassembled'^M^J);
					$40: WriteLn('; rts/brk/rti/jmp'^M^J);
					$60: h := False;
					Else WriteLn('; Something strange in disassembler'^M^J);
				End;
			End
		End
	End;

	SwapInOut;
	WriteLn('Writing data records.');
	SwapInOut;
	WriteLn('; There was supposed to be data in the following addresses:');

	For i := -8 To pROMCount-1 Do
	Begin
		k := i+8;

		If fROM[i] = Nil Then Continue;
		For b := 0 To 4095 Do
		Begin
			If Ord(fROM[i][b])And 12 <> 0 Then
			Begin
				If i >= 0
					Then Write('R')
					Else Write('D');

				If i < 0  Then
				Begin
					LHex(Buf, (Word(k)Shl 12) + b);
					Write(Buf+2)
				End
				Else If k < pROMCount-4 Then
				Begin
					l := (Word(8 + k And 3)Shl 12) + b;

					WordRec(LongRec(l).Hi).Lo := k Shr 2;

					LHex(Buf, l);
					Write(Buf+2)
				End
				Else
				Begin
					l := $C000 + b + (k And 3)Shl 12;

					LHex(Buf, l);
					Write(Buf+2)
				End;

				a := 1;
				If Ord(fROM[i][b])And 4 <> 0 Then
					For w := b+1 To 4095 Do
					Begin
						If Ord(fROM[i][w])And 12 <> 0 Then Break;
						Inc(a)
					End;

				Write(#9);
				If i >= 0 Then
				Begin
					Write('db'#9);
					If a = 1 Then
					Begin
						BHex(Buf, Ord(pROM[i][b]));
						Write('0',Buf,'h')
					End
					Else
					Begin
						w := b;
						j := i;
						o := 8;
						While a > 0 Do
						Begin
							If(o > 0)And(o < 8)Then Write(', ')
							Else If o = 0 Then
							Begin
								WriteLn;
								Write(#9'db'#9);
								o := 8
							End;
							BHex(Buf, Ord(pROM[j][w]));
							Write('0',Buf,'h');
							Inc(w);
							If w And $1000 <> 0 Then
							Begin
								w := 0;
								Inc(j)
							End;
							Dec(a);
							Dec(o)
						End;
						WriteLn
					End
				End
				Else
				Begin
					Write('db'#9);
					If a = 1
						Then Write('0')
						Else Write(a,' dup (0)')
				End;
				WriteLn
			End
		End
	End;
	SwapInOut;
	WriteLn('Everything done.');
End;

Var
	s: Array[0..127]Of Char;
Begin
	ClrScr;
	DirectVideo := False;

	GetArgStr(s, 1, 127);
	DoIt(s);

	Close(Output);
	SwapInOut;
	Close(Output)
End.

